/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	LumpGroupクラス
//			変更履歴
//				2004.01.08	新規作成	五木田 泰史
//
package jp.co.ntt.lms.xmo.LumpInsert;

import jp.co.ntt.lms.xmo.XMOException;
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.GroupAndPeople.GroupAndPeopleClient;

import java.util.Vector;

/**
 * LumpGroupAndPeopleクラスです。<BR>
 * このクラスはXMLファイルから取得した<BR>
 * 親子関係をメンバに設定します。<BR>
 *
 * @author Y.Gokita
 * @version 0.0.0.1 2004/01/08
 */
public abstract class LumpGroupAndPeople
{

	/** グループと人の種別定義値 */
	public final static int TYPE_GROUP  = 1;
	public final static int TYPE_PEOPLE = 0;

	/** 一括登録失敗フラグ */
	boolean boolFailFlag = false;

	/** 親クラスを保持します */
	private LumpGroupAndPeople mParent = null;

	/** 子供クラスリストを保持します */
	protected Vector mvecChildList       = new Vector();

	/** クラス種別を保持します */
	private int mintType               = TYPE_PEOPLE;

	/**
	 * 親クラスを設定します
	 * @param GroupAndPeople 親クラス
	 */
	public void setParent(LumpGroupAndPeople objParent)
	{
		mParent = objParent;
	}

	/**
	 * 親クラスを取得します
	 * @return GroupAndPeople 親クラス
	 */
	public LumpGroupAndPeople getParent()
	{
		return mParent;
	}

	/**
	 * 子供クラスリストに追加します
	 * @param GroupAndPeople 子供クラス
	 */
	public void addChild(LumpGroupAndPeople objChild)
	{
		mvecChildList.add(objChild);
		objChild.setParent(this);
	}

	/**
	 * 自身または配下が登録に失敗していた場合はtrueを返します。
	 * @return boolean true: 失敗している false: 失敗していない
	 */
	public boolean isFail() {
		// 自身が失敗していたらtrueを返す。
		if( boolFailFlag ) {
			return true;
		}

		// 子が失敗していたらtrueを返す。
		for( int i = 0; i < mvecChildList.size(); i++ ) {
			if(((LumpGroupAndPeople)mvecChildList.get(i)).isFail()) {
				return true;
			}
		}

		// 自身も子も失敗していない場合はfalseを返す。
		return false;
	}

	/**
	 * 子供クラスを取得します
	 * @param int インデックス
	 * @return GroupAndPeople 子供クラス
	 */
	public LumpGroupAndPeople getChild(int intIndex)
	{
		LumpGroupAndPeople objChild = null;
		try
		{
			objChild = (LumpGroupAndPeople)mvecChildList.get(intIndex);
		}
		catch(ArrayIndexOutOfBoundsException e)
		{
			return null;
		}
		return objChild;
	}

	/**
	 * 子供リスト数を取得します
	 * @param int 子供リスト数
	 */
	public int getChildCount()
	{
		return mvecChildList.size();
	}

	/**
	 * LumpGroupとLumpPeopleを追加します
	 * 実体はLumpGroupとLumpPeopleにあります
	 * @param DataAccess データアクセスクラス
	 * @param Vector 一括登録ユーザリスト
	 * @return void
	 */
	public abstract void insert(DataAccess objDa, Vector vctUserList,
						String strStartGroup)
		throws XMOException;

	/**
	 * クラス種別を設定します
	 * @param int クラス種別
	 */
	public void setType(int intType)
	{
		mintType = intType;
	}

	/**
	 * クラス種別を取得します
	 * @return int クラス種別
	 */
	public int getType()
	{
		return mintType;
	}

	/**
	 * DBとの親子関係を調べ、親子関係がXMLと同様ではない場合にXMLに合わせて
	 * 移動処理を行います。
	 * @return boolean true: 移動成功 false: 移動失敗
	 * @exception Exception RMI通信エラー
	 */
	protected boolean moveTree(String strID, DataAccess objDa)
		throws Exception
	{
		if( mParent == null ) {
			return false;
		}

		String strParentID = ((LumpGroup)mParent).getGroupID();

		// ツリーの移動
		GroupAndPeopleClient objGandP = new GroupAndPeopleClient();
		// 子IDで検索する
		objGandP.setWhereChildID( strID );

		// トランザクションの共有
		objGandP.setConnectionIndex( objDa.getConnectionIndex() );

		// 検索処理
		if( !objGandP.select() ) {
			return false;
		}

		if( objGandP.next() ) {
			String strParentIDTemp = objGandP.getParentID();
			// 親IDが異なる場合は移動する。
			if( strParentIDTemp != null && !strParentIDTemp.equals( strParentID ) ) {
				// 移動処理を行う。
				// 移動元ID
				String strSendID = strParentIDTemp + "^" + strID;
				// 移動先ID(親IDと親の親IDを取得する。)
				LumpGroup objGrandParent = (LumpGroup)mParent.getParent();
				String strRecieveID = "";
				if( objGrandParent != null ) {
					strRecieveID = objGrandParent.getGroupID() + "^" + strParentID;
				}
				else {
					GroupAndPeopleClient objGandP2 = new GroupAndPeopleClient();
					objGandP2.setWhereChildID( strParentID );
					// トランザクションの共有
					objGandP2.setConnectionIndex( objDa.getConnectionIndex() );
					if( !objGandP2.select() ) {
						return false;
					}

					if( objGandP2.next() ) {
						strRecieveID = objGandP2.getParentID() + "^" + strParentID;
					}
					else {
						// 親IDがDBから取得できない場合はROOTである。
						strRecieveID = "^" + strParentID;
					}
				}
				if( !objGandP.transfer( strSendID, strRecieveID, GroupAndPeopleClient.IN_TYPE ) ) {
					return false;
				}
			}
		}

		return true;
	}

	/**
	 * 指定されたID配下に所属追加します。
	 * @return boolean true: 成功 false: 失敗
	 * @exception Exception RMI通信エラー
	 */
	protected boolean copy(String strSendID, DataAccess objDa)
		throws Exception
	{
		if( mParent == null ) {
			return false;
		}

		String strParentID = ((LumpGroup)mParent).getGroupID();

		GroupAndPeopleClient objGandP = new GroupAndPeopleClient();
		// トランザクションの共有
		objGandP.setConnectionIndex( objDa.getConnectionIndex() );

		// 移動先ID(親IDと親の親IDを取得する。)
		LumpGroup objGrandParent = (LumpGroup)mParent.getParent();
		String strRecieveID = "";
		if( objGrandParent != null ) {
			strRecieveID = objGrandParent.getGroupID() + "^" + strParentID;
		}
		else {
			objGandP.setWhereChildID( strParentID );
			if( !objGandP.select() ) {
				return false;
			}

			if( objGandP.next() ) {
				strRecieveID = objGandP.getParentID() + "^" + strParentID;
			}
			else {
				// 親IDがDBから取得できない場合はROOTである。
				strRecieveID = "^" + strParentID;
			}
		}
		String[] strSendIDList = new String[1];
		strSendIDList[0] = strSendID;
		if( !objGandP.copy( strSendIDList, strRecieveID, GroupAndPeopleClient.IN_TYPE ) ) {
			return false;
		}

		return true;
	}

}

